package com.kuyuntech.cofarcooking.device.sdk.protocol.core.cmd;


import com.kuyuntech.cofarcooking.device.sdk.constant.core.CmdTypes;
import com.kuyuntech.cofarcooking.device.sdk.protocol.core.BaseBody;
import com.kuyuntech.cofarcooking.device.sdk.protocol.core.BaseDecoder;
import com.kuyuntech.cofarcooking.device.sdk.util.core.Converter;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.ToString;

@EqualsAndHashCode(callSuper = true)
@Data
@ToString
public class CfgMotorCmd extends BaseBody {

    private BaseBody baseBody;

    //指令类型
    private String cmd;

    //电机转向
    private String direction;

    //电机档位
    private String gear;

    //电机高低位选择
    private String hightSpeed;



    public CfgMotorCmd(String data){
        this(new BaseDecoder(data));
    }

    public CfgMotorCmd(BaseBody baseBody) {
        this.baseBody =baseBody;
        byte[] content = this.baseBody.getContent();
        int i = 0;
        this.cmd = Converter.bytesToHexString(new byte[]{content[i++],content[i++]},2);
        this.direction =  Converter.bytesToHexString(new byte[]{content[i++]},1);
        this.gear = Converter.bytesToHexString(new byte[]{content[i++]},1);
        this.hightSpeed = Converter.bytesToHexString(new byte[]{content[i]},1);
    }

    public CfgMotorCmd(BaseDecoder baseDecoder) {
         this(baseDecoder.getBaseBody());
    }

    public CfgMotorCmd(byte direction, byte gear,byte hightSpeed) {
        super(CmdTypes.CFG_MOTOR +Converter.bytesToHexString(new byte[]{direction,gear,hightSpeed}, 3) );
    }

}
